/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   TIMInterface.h
 * Author: jn250
 *
 * Created on 5. Oktober 2016, 08:40
 */

#ifndef TIMINTERFACE_H
#define TIMINTERFACE_H



#endif /* TIMINTERFACE_H */

class TTIMInterface
{
private:
	typedef unsigned (LOAD_INTERFACE)(const char*);
	LOAD_INTERFACE   *pLOAD_INTERFACE;

	typedef unsigned (TIM_SET_USS)(const char*, const char*, const char*, 
                                       const char*, const char*, const char*, 
                                       const char*);
	TIM_SET_USS   *pTIM_SET_USS;

	typedef unsigned (TIM_ADD_ITEM)(const char*, const char*, const char*, 
                                        const char*, const char*, const char*, 
                                        const char*, const char*, const char*, 
                                        const char*, const char*, const char*, 
                                        const char*);
	TIM_ADD_ITEM   *pTIM_ADD_ITEM;

	typedef unsigned (TIM_TRANSACTION)(const char*, const char*, const char*, 
                                           const char*, const char*, const char*, 
                                           const char*, const char*, char*);
	TIM_TRANSACTION   *pTIM_TRANSACTION;

	typedef unsigned (TIM_RESET_ITEMS)();
	TIM_RESET_ITEMS   *pTIM_RESET_ITEMS;

	typedef unsigned (TIM_REPORT)(const char*, const char*, const char*, 
                                      const char*, const char*, const char*, 
                                      char*);
	TIM_REPORT   *pTIM_REPORT;

	typedef unsigned (TIM_REPORT_SPAN)(const char*, const char*, const char*, 
                                           const char*, const char*, const char*, 
                                           const char*, char*);
	TIM_REPORT_SPAN   *pTIM_REPORT_SPAN;

	typedef unsigned (TIM_BOOKED_MONTHS)(char*);
	TIM_BOOKED_MONTHS   *pTIM_BOOKED_MONTHS;

	typedef unsigned (TIM_INFORMATION)(char*);
	TIM_BOOKED_MONTHS   *pTIM_INFORMATION;

	typedef unsigned (TIM_CERTIFICATE)(char*);
	TIM_BOOKED_MONTHS   *pTIM_CERTIFICATE;

	typedef unsigned (TIM_ACTIVATE)(const char*, const char*, const char*, 
                                        const char*, char*);
	TIM_ACTIVATE   *pTIM_ACTIVATE;

	typedef unsigned (TIM_DEBUG_MODE)(const unsigned);
	TIM_DEBUG_MODE   *pTIM_DEBUG_MODE;

public:
	TTIMInterface();
	unsigned Call_LOAD_INTERFACE(const char* Name);
	unsigned Call_TIM_SET_USS(const char* USS1, const char* USS2, 
                                  const char* USS3, const char* USS4, 
                                  const char* USS5, const char* USS6, 
                                  const char* VatADDON);
	unsigned CALL_TIM_ADD_ITEM (const char* quantity, const char* unit, 
                                    const char* name, const char* is_discount, 
                                    const char* is_voucher, const char* val1, 
                                    const char* val2, const char* val3, 
                                    const char* val4, const char* val5, 
                                    const char* val6, const char* val7, 
                                    const char* val8);
	unsigned CALL_TIM_TRANSACTION (const char* year_YYYY, const char* month_MM, 
                                       const char* day_DD, const char* hour_hh, 
                                       const char* minutes_mm, const char* operator_name, 
                                       const char* VatADDON, const char* Training, 
                                       char* DataOut);
	unsigned CALL_TIM_RESET_ITEMS();
        unsigned CALL_TIM_REPORT (const char* year_YYYY, const char* month_MM, 
                                  const char* day_DD, const char* hour_hh, 
                                  const char* minutes_mm, const char* is_signed, 
                                  char* DataOut);
	unsigned CALL_TIM_REPORT_SPAN(const char* year_YYYY, const char* month_MM, 
                                      const char* day_DD, const char* hour_hh, 
                                      const char* minutes_mm, const char* first_month_YYYYMM, 
                                      const char* last_month_YYYYMM, 
                                      char* DataOut);
	unsigned CALL_TIM_BOOKED_MONTHS(char* DataOut);
	unsigned CALL_TIM_INFORMATION(char* DataOut);
	unsigned CALL_TIM_CERTIFICATE(char* DataOut);
	unsigned CALL_TIM_ACTIVATE (const char* year_YYYY, const char* month_MM, 
                                    const char* day_DD, const char* PIN, 
                                    char* DataOut);
	unsigned CALL_TIM_DEBUG_MODE(const unsigned mode);
	
        char  ResultData [4096];
};

