/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

#include <stdarg.h>
#include <WinDef.h>
#include <winbase.h>
#include "TIMInterface.h"


TTIMInterface::TTIMInterface()
{
	HINSTANCE hInstance;
	LPCSTR DLLName = "TIMinterface.dll";
	hInstance = ::LoadLibrary(DLLName);
	pLOAD_INTERFACE = (LOAD_INTERFACE*)::GetProcAddress((HMODULE)hInstance, "LOAD_INTERFACE");
	pTIM_SET_USS = (TIM_SET_USS*)::GetProcAddress((HMODULE)hInstance, "TIM_SET_USS");
	pTIM_ADD_ITEM = (TIM_ADD_ITEM*)::GetProcAddress((HMODULE)hInstance, "TIM_ADD_ITEM");
	pTIM_TRANSACTION = (TIM_TRANSACTION*)::GetProcAddress((HMODULE)hInstance, "TIM_TRANSACTION");
	pTIM_RESET_ITEMS = (TIM_RESET_ITEMS*)::GetProcAddress((HMODULE)hInstance, "TIM_RESET_ITEMS");
	pTIM_REPORT = (TIM_REPORT*)::GetProcAddress((HMODULE)hInstance, "TIM_REPORT");
	pTIM_REPORT_SPAN = (TIM_REPORT_SPAN*)::GetProcAddress((HMODULE)hInstance, "TIM_REPORT_SPAN");
	pTIM_BOOKED_MONTHS = (TIM_BOOKED_MONTHS*)::GetProcAddress((HMODULE)hInstance, "TIM_BOOKED_MONTHS");
	pTIM_INFORMATION = (TIM_INFORMATION*)::GetProcAddress((HMODULE)hInstance, "TIM_INFORMATION");
	pTIM_CERTIFICATE = (TIM_CERTIFICATE*)::GetProcAddress((HMODULE)hInstance, "TIM_CERTIFICATE");
	pTIM_ACTIVATE = (TIM_ACTIVATE*)::GetProcAddress((HMODULE)hInstance, "TIM_ACTIVATE");
	pTIM_DEBUG_MODE = (TIM_DEBUG_MODE*)::GetProcAddress((HMODULE)hInstance, "SET_DEBUG_MODE");
}


unsigned TTIMInterface::Call_LOAD_INTERFACE(const char * Name)
{
	return pLOAD_INTERFACE(Name);
}

unsigned TTIMInterface::Call_TIM_SET_USS(const char * USS1, const char * USS2, const char * USS3, const char * USS4, const char * USS5, const char * USS6, const char * VatADDON)
{
	return pTIM_SET_USS(USS1, USS2, USS3, USS4, USS5, USS6, VatADDON);
}

unsigned TTIMInterface::CALL_TIM_ADD_ITEM(const char * quantity, const char * unit, const char * name, const char * is_discount, const char * is_voucher, const char * val1, const char * val2, const char * val3, const char * val4, const char * val5, const char * val6, const char * val7, const char * val8)
{
	return pTIM_ADD_ITEM(quantity, unit, name, is_discount, is_voucher, val1, val2, val3, val4, val5, val6, val7, val8);
}

unsigned TTIMInterface::CALL_TIM_TRANSACTION(const char * year_YYYY, const char * month_MM, const char * day_DD, const char * hour_hh, const char * minutes_mm, const char * operator_name, const char * VatADDON, const char * Training, char * DataOut)
{
	return pTIM_TRANSACTION(year_YYYY, month_MM, day_DD, hour_hh, minutes_mm, operator_name, VatADDON, Training, DataOut);
}

unsigned TTIMInterface::CALL_TIM_RESET_ITEMS()
{
	return pTIM_RESET_ITEMS();
}

unsigned TTIMInterface::CALL_TIM_REPORT(const char * year_YYYY, const char * month_MM, const char * day_DD, const char * hour_hh, const char * minutes_mm, const char * is_signed, char * DataOut)
{
	return pTIM_REPORT(year_YYYY, month_MM, day_DD, hour_hh, minutes_mm, is_signed, DataOut);
}

unsigned TTIMInterface::CALL_TIM_REPORT_SPAN(const char * year_YYYY, const char * month_MM, const char * day_DD, const char * hour_hh, const char * minutes_mm, const char * first_month_YYYYMM, const char * last_month_YYYYMM, char * DataOut)
{
	return pTIM_REPORT_SPAN(year_YYYY, month_MM, day_DD, hour_hh, minutes_mm, first_month_YYYYMM, last_month_YYYYMM, DataOut);
}

unsigned TTIMInterface::CALL_TIM_BOOKED_MONTHS(char * DataOut)
{
	return pTIM_BOOKED_MONTHS(DataOut);
}

unsigned TTIMInterface::CALL_TIM_INFORMATION(char * DataOut)
{
	return pTIM_INFORMATION(DataOut);
}

unsigned TTIMInterface::CALL_TIM_CERTIFICATE(char * DataOut)
{
	return pTIM_CERTIFICATE(DataOut);
}

unsigned TTIMInterface::CALL_TIM_ACTIVATE(const char * year_YYYY, const char * month_MM, const char * day_DD, const char * PIN, char * DataOut)
{
	return pTIM_ACTIVATE(year_YYYY, month_MM, day_DD, PIN, DataOut);
}

unsigned TTIMInterface::CALL_TIM_DEBUG_MODE(const unsigned mode)
{
	return pTIM_DEBUG_MODE(mode);
}
